#! /bin/sh
eval '(exit $?0)' && eval 'PERL_BADLANG=x;PATH="$PATH:.";export PERL_BADLANG\
 PATH;exec perl -x -S -- "$0" ${1+"$@"};#'if 0;eval 'setenv PERL_BADLANG x\
;setenv PATH "$PATH":.;exec perl -x -S -- "$0" $argv:q;#'.q
#!perl -w
+push@INC,'.';$0=~/(.*)/s;do(index($1,"/")<0?"./$1":$1);die$@if$@__END__+if 0
;#Don't touch/remove lines 1--7: http://www.inf.bme.hu/~pts/Magic.Perl.Header
#
# postootex.pl -- further convert the LaTeX output of OpenOffice 2.0.4
# by pts@fazekas.hu at Thu Nov  9 19:41:39 CET 2006
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#
# Usage: pstootex.pl <in.tex >out.tex
#
# The fundamental functionality of this Perl script is:
#
# -- inserting \begin{verbatim} automatically
# -- converting to ISO-8859-2 encoding
#
# Dat: the conversion tries to be as good as possible, but is not
#      100% accurate
# Dat: we assume there is no \verb or \begin{verbatim}
# Dat: doesn't fix \t (tab) properly in the source file, a tab has already
#      been converted to a space by the time we read it :-(
# Imp: fix \t in \begin{verbatim} anyway
# Imp: \s for TeX and Perl
# Imp: warning if .tex source contains `[2D8?]' (for char 162)
# !! in \href{A}{B}, keep only B
# !! test for \begin{verbatim} in input
# !! \subsubsection -> \paragraph
# !! remove space at end of `\begin {enumerate} '
#

use integer;
use strict;

# --- Configuration

use vars qw($SourceLineLength);
#** Break source lines at this position if possible. Don't break
#** comments or \begin{verbatim}
$SourceLineLength=50;

# --- from texmacro.pm

use vars qw($ControlSequenceRegexp $ControlSequenceNoSpaceRegexp
  $SpaceRegexp $CommentRegexp);

$SpaceRegexp=qr{[\t \r\n]};
#$ControlSequenceNoSpaceRegexp=qr{\\(?:[A-Za-z\@]+|[^A-Za-z\@])};
#$ControlSequenceRegexp=qr{\\(?:[A-Za-z\@]+(?:$SpaceRegexp)*|[^A-Za-z\@])};
$CommentRegexp=qr{\%[^\n]*(?:\n(?:$SpaceRegexp)*)?};

#** Adjust pos($_). Skips a properly, {...} delimited substring.
#** @param $_[0] should start with \{? If negative, yes, but assume that
#**   \{ is already processed
#** @return String. The text skipped, without comments.
sub get_nested($) {
  ##print STDERR pos($_).":".substr($_,pos($_)).";;\n";
  #die pos($_).substr($_,pos($_)) if !scalar(...)
  /\G(?:$CommentRegexp)+/gc;
  my $mindepth1_p=$_[0];
  my $depth=0;
  if ($mindepth1_p<0) {
    $depth=-$mindepth1_p;
  } elsif ($mindepth1_p) {
    die "missing open brace" if !/\G\{/gc; #/
    $depth=1;
  }
  my $ret="";
  while (/\G([^\{\}\%\\]+|(\{)|(\})|(\\)|($CommentRegexp)|[^\{\}])/gc) { # Imp: compile once
    ##print "GOT=($1)\n";
    if (defined $2) {
      $depth++; $ret.=$1
    } elsif (defined $3) {
      die "extra close brace" if 0>--$depth;
      $ret.=$1
    } elsif (defined $4) {
      if (/\G([A-Za-z\@]+)(?:$SpaceRegexp)*/gc) { $ret.="\\$1 " }
      elsif (/\G([^A-Za-z@])/gc) { $ret.="\\$1" }
    } elsif (defined $5) { # Dat: skip comment
    } elsif ($depth==0 and length($1)>1 and !$mindepth1_p) {
      $ret.=substr($1,0,1);
      pos($_)+=1-length($1);
    } else { $ret.=$1 }
    last if 0==$depth;
  }
  die "missing close brace" if pos($_)==length($_) and $depth!=0;
  if ($mindepth1_p) { substr($ret,-1)="" } # Dat: remove close brace
  elsif (0==length($ret)) { die "missing token" }
  $ret
}

#** Adjust pos($_).
#** @return String. The skipped parameter.
sub get_undelimited_param() {
  /\G(?:$SpaceRegexp|$CommentRegexp)+/gc; # Dat: skip blanks
  get_nested(/\G(?=\{)/gc ? 1 : 0)
}

#** Counts the maximum number of backslashes from endofs-1 backwards in string.
#** @param $_[0] string
#** @param $_[1] endofs
sub back_backslash_count($$) {
  my $I=$_[1];
  $I-- while $I>0 and substr($_[0],$I-1,1)eq"\\";
  $_[1]-$I
}

#** Adjust pos($_), skips $delimiter too.
#** @param $_[0] String. The delimiter (comments removed, space added after
#**   alphabetic control sequences). Braces outside
#**   control sequences disallowed.
#** @param $_[1] remove a level of braces? True by default.
#** @return String. The skipped parameter.
sub get_delimited_param($;$) {
  my $rm_braces_p=$_[1];
  $rm_braces_p=1 if !defined $rm_braces_p;
  /\G(?:$SpaceRegexp|$CommentRegexp)+/gc; # Dat: skip blanks; Dat: this makes further zero-width regexps not match
  ##print STDERR pos($_)."\n";
  #die "X".scalar($_=~/\G(zzzz)*/gc);
  my $delim=$_[0];
  my $ret="";
  die if length($delim)<1;
  while (length($ret)<length($delim)
      or substr($ret,-length($delim))ne$delim
      or back_backslash_count($ret,length($ret)-length($delim))%2!=0
        ) {
    $ret.=get_nested(0); # Dat: always makes some progress
    #print "RET=($ret)\n";
  }
  substr($ret,-length($delim))='';
  my $savepos=pos($_);
  if ($rm_braces_p and substr($ret,0,1)eq'{' and substr($ret,-1)eq'}') {
    local $_=$ret; pos($_)=0; # SUXX: local doesn't save it properly
    substr($ret,0,1)=substr($ret,-1)='' if ($ret eq get_nested(0)); # Imp: faster check
  }
  pos($_)=$savepos;
  $ret        
}

#** @param $_[0] String. The delimiter (comments removed, space added after
#**   alphabetic control sequences). Braces outside
#**   control sequences disallowed. To be passed to get_delimited_param()
#** @param $_[1] String. To be split.
#** @return arrayref of splitted strings
sub split_on($$) {
  my $delim=$_[0];
  local $_=$_[1].$delim; pos($_)=0; # SUXX: `local' doesn't save it properly
  my $ret=[];
  while (pos($_)<length($_)) {
    push @$ret, get_delimited_param($delim,0);
  }
  $ret
}

$_="{alma}ko\\\\\\ma r%zert\n  te{szilva}\\\\mart\\ma"; pos($_)=0;
  die if get_delimited_param("ma") ne "{alma}ko\\\\\\ma rte{szilva}\\\\";
$_="{alma}ko\\\\ma r%zert\n  te{szilva}\\\\mart\\manyi\\ma ri"; pos($_)=0;
  die if get_delimited_param("\\ma ") ne "{alma}ko\\\\ma rte{szilva}\\\\mart\\manyi ";
$_="{foo\\bar}\@sofar"; pos($_)=0;
  die if get_delimited_param("@") ne "foo\\bar ";
$_=" {fo\\}o}{\\bar}\@sofar"; pos($_)=0;
  die if get_delimited_param("@") ne "{fo\\}o}{\\bar }";
$_="  {fo\\}o}{\\bar}\@sofar"; pos($_)=0;
  die if get_undelimited_param() ne "fo\\}o";
$_="  \\%o{\\bar}\@sofar"; pos($_)=0;
  die if get_undelimited_param() ne "\\%";

# ---

$_=join'',<STDIN>;
s@\r\011\013\f\000@@g; # Dat: remove irregular whitespace, keep only 

#** Each item of @parts is a hashref with src=> and type=>.
my @parts;
while (m@
  ((?:%[^\n]*(?:\n\s*)?)+) # series of comments
 |( [^\\%]+(\\.[^\\%]*)* | \\.([^\\%]*\\.)*[^\\%]* ) # normal source code
 |.
 @gsx) {
  if (defined $1) {
    push @parts, { src=>$1, type=>'comment' };
  } elsif (defined $2) {
    my $S=$2;
    $S=~s@\\\\|(\\.)@defined($1) ? $1 : "\\BACKSLASH "@gse; # Dat: remove \\ for easier parsing
    $S=~s@(\\(?:begin|end)\{document\})@\n\n$1\n\n@g;
    $S=~s@[ \t]*\n[ \t]*(?:\n[ \t]*)+@\n\n@g; # condense paragraph terminator
    $S=~s@(\n\n)|\n(?![ \t\n])|\n?[ \t][ \t\n]*@ defined($1) ? $1 : " " @ge; # compress lines, remove extra whitespace
    $S=~s/(\\[a-zA-Z\@]+)\s*/$1 /g; # Dat: single space after word control sequences
    die if $S=~m@\n\n\s@;
    push @parts, { src=>$S, type=>'normal' };
  } else {
    die "$0: syntax error $& ($.)\n";
  }
}

#** Skip argument of \section in $_
#** @return name of the section, in {...}
sub get_section_arg() {
  /\G +/gc;
  if (/\G[*]/gc) {}
  elsif (/\G\[/gc) { get_delimited_param(']') }
  get_undelimited_param();
}

# Convert to ISO-8859-2 (\usepackage[latin2]{inputenc})
use vars qw($AsciiRegexp %AsciiReplace);
# vvv Dat: these are the high Latin-2
#     characters, as exported by OpenOffice 2.0.4
%AsciiReplace=map { my($a,$b)=split(/-/,$_,2);
  $b=~s/(\\[A-Za-z\@]+)\s*/$1 /g;
  $b=>chr($a) } qw(
  161-\k{A}
  163-{\L}
  164-{\textcurrency}
  165-\v{L}
  166-\'S
  167-{\S}
  168-{\textasciidieresis}
  169-\v{S}
  170-\c{S}
  171-\v{T}
  172-\'Z
  173-\-
  174-\v{Z}
  175-\.Z
  176-{\textdegree}
  177-\k{a}
  179-{\l}
  180-{\textasciiacute}
  181-\v{l}
  182-\'s
  184-\c{}
  185-\v{s}
  186-\c{s}
  187-\v{t}
  188-\'z
  190-\v{z}
  191-\.z
  192-\'R
  193-\'A
  194-\^A
  195-\u{A}
  196-\"A
  197-\'L
  198-\'C
  199-\c{C}
  200-\v{C}
  201-\'E
  202-\k{E}
  203-\"E
  204-\v{E}
  205-\'I
  206-\^I
  207-\v{D}
  208-{\DJ}
  209-\'N
  210-\v{N}
  211-\'O
  212-\^O
  213-\H{O}
  214-\"O
  215-{\texttimes}
  216-\v{R}
  217-\r{U}
  218-\'U
  219-\H{U}
  220-\"U
  221-\'Y
  222-\c{T}
  223-{\ss}
  224-\'r
  225-\'a
  226-\^a
  227-\u{a}
  228-\"a
  229-\'l
  230-\'c
  231-\c{c}
  232-\v{c}
  233-\'e
  234-\k{e}
  235-\"e
  236-\v{e}
  237-\'i
  238-\^i
  239-\v{d}
  240-{\dj}
  241-\'n
  242-\v{n}
  243-\'o
  244-\^o
  245-\H{o}
  246-\"o
  247-{\textdiv}
  248-\v{r}
  249-\r{u}
  250-\'u
  251-\H{u}
  252-\"u
  253-\'y
  254-\c{t}
); #"
$AsciiRegexp=join('|', map { quotemeta($_) } keys %AsciiReplace);
$AsciiRegexp=qr/($AsciiRegexp)/;
for my $part (@parts) {
  next if $part->{type} ne 'normal';
  $part->{src}=~s@$AsciiRegexp@$AsciiReplace{$1}@g;
}

# Put \n\n after \section*[...]{...}
for my $part (@parts) {
  next if $part->{type} ne 'normal';
  $_=$part->{src}; pos($_)=0;
  while (/(\s*\\(?:(?:section|subsection|subsubsection|subsubsubsection|(?:sub)?paragraph)|(bigskip|medskip|smallskip|item|(?:begin|end) \{(?:enumerate|enumerate|description|quote|quotation|center)\})) +)/g) {
    # Imp: don't remove * from `\section*' ?
    my $pre=$1;
    my $simple_command_p=defined($2) ? 1 : 0;
    my $item_p=(defined $2 and $2 eq 'item') ? 1 : 0;
    my $pos0=pos($_)-length($pre);
    $pre=~s@\A\s*@\n\n@;
    my $repl=$pre;
    #** Whitespace to append.
    my $postws="\n\n";
    if ($item_p) {
      $postws=""; # Dat: we already have a space after
    } elsif (!$simple_command_p) {
      my $caption=get_section_arg();
      $caption=~s@\A(?: |\\ )+@@g;
      $caption=~s@(?: |\\ )+\Z(?!\n)@@g;
      # print STDERR "$pre:$caption\n";
      $repl.="{$caption}";
    }
    /\G\s*/gc;
    substr($_,$pos0,pos($_)-$pos0)=$repl.$postws;
    pos($_)=$pos0+length($repl); # Dat: don't count length($postws);
  }
  s/(\\[a-zA-Z\@]+)\s*/$1 /g; # Dat: add single space after word control sequences, removed by \s* in while(/.../)
  $part->{src}=$_;
}

# Get rid of \upshape, \mdseries, \rmfamily, \textrm, \textup, \textmd.
# Dat: this must be done before \begin{verbatim}
# Dat: don't remove the braces arond {\rmfamily ... }, because of
#      \section{\rmfamily ...}
{ for my $part (@parts) {
    next if $part->{type} ne 'normal';
    # vvv Dat: we need a while loop to apply recursively
    while ($part->{src}=~m@\\(?:upshape|mdseries|rmfamily|textrm|textup|textmd) @) {
      $_=$part->{src}; pos($_)=0;
      while (m@(\{\\(upshape|mdseries|rmfamily) +|\\(?:textrm|textup|textmd) +\{)@g) {
        my $keep_braces_p=defined($2) ? 1 : 0;
        my $pos0=pos($_)-length($1);
        my $arg=get_nested(-1);
	$arg="{$arg}" if $keep_braces_p;
        substr($_,$pos0,pos($_)-$pos0)=$arg;
        pos($_)=$pos0+length($arg);
      }
      last if $part->{src} eq $_;
      $part->{src}=$_;
    }
  }
}

# Get rid of \selectlanuage{FOO} and \foreignlanguage{FOO} and \color{BAR}
# and \pagestyle{STANDARD} and \textcolor{BAR}
{ for my $part (@parts) {
    next if $part->{type} ne 'normal';
    if ($part->{src}=~m@\\(?:selectlanguage|foreignlanguage|color|textcolor|(?:this)?pagestyle) @) {
      $_=$part->{src}; pos($_)=0;
      while (m@(\\(?:selectlanguage|foreignlanguage|color|textcolor|(?:this)?pagestyle) +\{)@g) {
        my $pos0=pos($_)-length($1);
        get_nested(-1); # Dat: ignore argument
        substr($_,$pos0,pos($_)-$pos0)="";
        pos($_)=$pos0;
      }
      $part->{src}=$_;
    }
  }
}

# Get rid of \liststyleL...
# !! get rid of empty $part->{src}
{ for my $part (@parts) {
    # Imp: don't replace \newcommand\liststyleL
    next if $part->{type} ne 'normal';
    if ($part->{src}=~m@\\(?:liststyleL)@) {
      $_=$part->{src}; pos($_)=0;
      s@(\s*)\\(?:liststyleL[A-Za-z\@]+)(\s*)@$1$2@g; # Imp: compress \n\n\n
      $part->{src}=$_;
    }
  }
}

#for my $part (@parts) { print $part->{src} }; die "D";

#** Skips past a verbatim line starting at pos($_).
#** @return :String containing the LaTeX source of the line or undef,
#**   without "\n" at the end
sub get_verbatim_line() {
  if (m@\G(?:\{\\ttfamily |\\(?:texttt|textstyleSourceText|textstyleTeletype) \{)@gc) { # Imp: get rid of copies of these regexps in the code
    my $pos0=pos($_);
    my $arg=get_nested(-1);
    if (pos($_)==length($_)) { $arg }
    elsif (substr($_,pos($_),2)eq"\n\n") { pos($_)+=2; $arg }
    else { pos($_)=$pos0; undef }
  } elsif (m@\G\\bigskip\s*@gc) {
    ""
  } else { undef }
}

use vars qw(%VerbatimReplace $VerbatimRegexp);
#$VerbatimReplace{q~{}-~}='-';
$VerbatimReplace{q~\upshape ~}='';
$VerbatimReplace{q~\mdseries ~}='';
$VerbatimReplace{q~\rmfamily ~}='';
$VerbatimReplace{q~\ttfamily ~}='';
$VerbatimReplace{'~'}=' ';
#$VerbatimReplace{'{'}=''; # Dat: must be put late
$VerbatimReplace{'}'}='';
$VerbatimReplace{q/\#/}=chr(31);
$VerbatimReplace{q/\ /}=chr(32);
$VerbatimReplace{q/!/}=chr(33);
$VerbatimReplace{q/{\textquotedbl }/}=chr(34);
$VerbatimReplace{q/\#/}=chr(35);
$VerbatimReplace{q/\$/}=chr(36);
$VerbatimReplace{q/\%/}=chr(37);
$VerbatimReplace{q/\&/}=chr(38);
$VerbatimReplace{q/{\textquotesingle }/}=chr(39);
$VerbatimReplace{q/{}-/}=chr(45);
$VerbatimReplace{q/{\textless }/}=chr(60);
$VerbatimReplace{q/{\textgreater }/}=chr(62);
$VerbatimReplace{q/{\textbackslash }/}=chr(92);
$VerbatimReplace{q/\^{}/}=chr(94);
$VerbatimReplace{q/\_/}=chr(95);
$VerbatimReplace{q/{\textasciigrave }/}=chr(96);
$VerbatimReplace{q/\{/}=chr(123);
$VerbatimReplace{q/{\textbar }/}=chr(124);
$VerbatimReplace{q/\}/}=chr(125);
$VerbatimReplace{q/\~{}/}=chr(126);
$VerbatimReplace{q/\textit /}=''; # Imp: smarter, warning
$VerbatimReplace{q/\textstyleSourceText /}='';
$VerbatimReplace{q/\textstyleTeletype /}='';
$VerbatimReplace{q/\texttt /}='';

$VerbatimRegexp=join('|', (map { quotemeta($_) } keys %VerbatimReplace),'{');
$VerbatimReplace{'{'}='';
$VerbatimRegexp=qr/($VerbatimRegexp)/;

sub conv_verbatim_line($) {
  # Dat: might contain \mdseries -> ignore
  my $S=$_[0];
  #print STDERR "CONV($S)\n";
  $S=~s@$VerbatimRegexp|(\{?\\[A-Za-z\@]+ |\{?\\.|[{}\%\$])@
    if (defined $2) {
      die "unexpected in verbatim: $2\n";
    } else {
      die if !defined $VerbatimReplace{$1};
      $VerbatimReplace{$1}
    }
  @gse;
  "$S\n"
}

# Find find type->'verbatim'
{ my $I;
  for ($I=0;$I<@parts;$I++) {
    my $part=$parts[$I]; 
    next if $part->{type} ne 'normal';
    if ($part->{src}=~m@(?:\A|\n\n)(?:\{\\ttfamily |\\(?:texttt|textstyleSourceText|textstyleTeletype) \{)@) {
      $_=$part->{src}; pos($_)=0;
      my $add_p=0;
      while (m@(?:\A|\n\n)((?:\{\\ttfamily |\\(?:texttt|textstyleSourceText|textstyleTeletype) \{))@g) {
        my $pos0=pos($_)-length($1);
        # Dat: keep \n\n before begin{verbatim}
        pos($_)=$pos0;
        my $line=get_verbatim_line();
        #print STDERR "L($line)\n";
        if (defined $line) {
          my $body="\\begin {verbatim}\n";
          while (defined $line) {
            $body.=conv_verbatim_line($line);
            $line=get_verbatim_line();
          }
          /\G\s+/gc;
          $body.="\\end {verbatim}\n\n";
          # Imp: faster, don't clobber $_ in O(n^2)
          $part->{src}=substr($_,0,$pos0);
          if (0!=length($part->{src})) {
            splice(@parts,++$I,0,undef,undef);
          } else {
            splice(@parts,$I+1,0,undef);
          }
          $parts[$I++]={ type=>'verbatim', src=>$body };
          substr($_,0,pos($_))=""; pos($_)=0;
          $parts[$I]=$part={ type=>'normal', src=>$_ };
        }
      }
      if (0==length($_)) {
        splice(@parts,$I--,1);
      }
    }
  }
}

use vars qw(%TrivReplace $TrivRegexp);
$TrivReplace{q~{}-~}='-';
$TrivReplace{q~{--}~}='--';
$TrivReplace{q~\\bigskip ~}=''; # Imp: compress spaces
$TrivReplace{q~{\quotedblbase }~}=',,';
$TrivReplace{q~\\ ~}=''; # Imp: only around spaces
$TrivReplace{q~\newline ~}='';
$TrivReplace{q~\newpage ~}='';
$TrivReplace{q~\clearpage ~}='';
$TrivReplace{q~\cleardoublepage ~}='';
$TrivReplace{q~\textstyleTeletype ~}='\texttt ';
$TrivReplace{q~\textstyleSourceText ~}='\texttt ';
$TrivReplace{q~\textit ~}='\emph ';
$TrivRegexp=join('|', map { quotemeta($_) } keys %TrivReplace);
$TrivRegexp=qr/($TrivRegexp)/;
for my $part (@parts) {
  next if $part->{type} ne 'normal';
  $part->{src}=~s@$TrivRegexp@$TrivReplace{$1}@g;
}

# Remove {...} braces for whole paragraphs and \items

for my $part (@parts) {
  next if $part->{type} ne 'normal';
  if ($part->{src}=~m@(?:\A|\n\n)(?:\\item +)?\{@) {
    $_=$part->{src}; pos($_)=0;
    while (m@(?:\A|\n\n)(?:\\item +)?(\{\s*)@g) {
      my $pos0=pos($_);
      my $pos1=pos($_)-length($1);
      my $arg; eval { $arg=get_nested(-1) };
      if (defined($arg) and /\G *(?:\n\n|\Z(?!\n))/) {
        substr($_,$pos1,pos($_)-$pos1)=$arg; # Dat: remove braces
	pos($_)=$pos1+length($arg);
      } else { pos($_)=$pos0 }
    }
    $part->{src}=$_;
  }      
}


# Remove everything up to \begin{document}
{ my $I;
  for ($I=0;$I<@parts;$I++) {
    my $part=$parts[$I];
    if ($part->{type} eq 'normal' and $part->{src}=~s@.*?\\begin {document}\s*@@s) {
      $I++ if 0==length($part->{src});
      splice(@parts,0,$I); last
    }
  }
}

# Remove everything beyond \end{document}
{ my $I;
  for ($I=0;$I<@parts;$I++) {
    my $part=$parts[$I];
    if ($part->{type} eq 'normal' and $part->{src}=~s@\s*\\end {document}.*@@s) {
      $I++ if 0!=length($part->{src});
      splice(@parts,$I); last
    }
  }
}


for my $part (@parts) {
  next if $part->{type} ne 'normal';
  $part->{src}=~s@\\BACKSLASH @\\@g;
}

# Break words at $SourceLineLength
# Dat: this messes up the the preamble quite much...
for my $part (@parts) {
  next if $part->{type} ne 'normal';
  $_=$part->{src};
  #** Position after last \n
  my $nlpos=0;
  #** Position after last space after last \n
  my $sppos=0;
  my $I=0;
  while ($I<length($_)) {
    my $C=substr($_,$I++,1);
    if ($C eq "\n") { $nlpos=$sppos=$I }
    elsif ($C eq " ") { $sppos=$I }
    elsif ($sppos>$nlpos and $I-$nlpos>$SourceLineLength) {
      # Break the line at $sppos. This works even for `\ '
      substr($_,$sppos-1,1)="\n";
      $nlpos=$sppos;
    }
  }
  $part->{src}=$_;
}

if (@parts) {
  $parts[-1]->{src}=~s@\s*\Z(?!\n)@\n@;
}

for (my $I=0;$I<@parts;$I++) {
  my $part=$parts[$I];
  if ($part->{type} eq 'normal' and substr($part->{src},-1)ne"\n" and
      defined $parts[$I+1] and $parts[$I+1]->{type}eq'comment') {
    $part->{src}=~s@\s+\Z(?!\n)@\n@g;
  }
}
  
for my $part (@parts) {
  #print "|";
  print $part->{src};
}
